<template lang="html">
  <div class="loader-container">
    <slot></slot>
    <div class="loader-backdrop" :style="`background-color: ${backdropColor}`" v-if="showLoader"></div>
    <div class="loader-icon" v-if="showLoader">
      <ficon name="loading" class="animate-spin" />
      <p v-if="text">
        {{text}}
      </p>
    </div>
  </div>
</template>

<script>
  import ficon from './ficons-component.vue'
  import { EventBus } from '../config/event-bus'

  import animationscss from '../assets/fonts/feira-icons/css/animation.css'

  export default {
    name: "LoaderComponent",
    components: { ficon },
    props: {
      backdropColor: {
        type: String
      },
      show: {
        type: Boolean,
        default: false
      },
      text: {
        type: String
      },
      listenFor: {
        type: String
      }
    },
    data() {
      return {
        showLoader: false
      }
    },
    mounted() {
      this.showLoader = this.show;
      EventBus.$on(`${this.listenFor}:INIT`, (payload) => {
        this.showLoader = true;
        this.$emit("loadingstart", { id: `${this.listenFor}:INIT` });
      })
      EventBus.$on(`${this.listenFor}`, (payload) => {
        this.showLoader = false;
        this.$emit("loadingend", { id: `${this.listenFor}` });
      })
    },
    watch: {
      show(value) {
        if (typeof value === "boolean") {
          this.showLoader = value;
        }
      }
    }
  }
</script>

<style lang="scss">
  .loader-container {
    position: relative;
    min-height: 100px;
    .loader-backdrop {
      position: absolute;
      top: 0;
      right: 0;
      left: 0;
      bottom: 0;
      background-color: #000;
      opacity: 0.7;
      z-index: 100;
    }
    .loader-icon {
      position: absolute;
      top: 0;
      right: 0;
      left: 0;
      bottom: 0;
      z-index: 101;
      color: #37C0C8;
      text-align: center;
      display: flex;
      align-items: center;
      justify-content: center;
      flex-direction: column;
      i {
        font-size: 60px;
      }
    }
  }
</style>
